set title  "Harmonic oscillator with Euler"
set key left top
set xlabel "time "
set ylabel "x, v, or E"
set xrange [0:10]

# set terminal x11 enhanced font 'Verdana,20' persist
set terminal qt enhanced font 'Verdana,20' persist

plot "spring.dat" using 1:2 title 'position' with lines, \
     "spring.dat" using 1:3 title 'velocity' w lines, \
     "spring.dat" using 1:4 title 'energy' w lines

set term postscript enhanced color eps
set output "euler.eps"

plot "spring.dat" using 1:2 title 'position' with lines, \
     "spring.dat" using 1:3 title 'velocity' w lines, \
     "spring.dat" using 1:4 title 'energy' w lines

set term pdf size 3in,3in font 'Times-Roman,12' 
set output "euler.pdf"

plot "spring.dat" using 1:2 title 'position' with lines, \
     "spring.dat" using 1:3 title 'velocity' w lines, \
     "spring.dat" using 1:4 title 'energy' w lines
